import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class Creator extends HFrame implements ActionListener
{
 private HTextField text;
 private HButton ok = new HButton("Create directory...");
 private HButton cancel = new HButton("Cancel");
 private HPanel okP = new HPanel();
 private DirPanel who = null;
 private String type = null;

public Creator(String l, String type, DirPanel who)
{
 this.who = who;
 this.type = type;

 setSize(300,100);
 setTitle("Choose...");
 setLocation(150,150);
 setLayout(new BorderLayout(10,10));

 text = new HTextField(l,"");
 okP.add(ok);
 okP.add(cancel);
 add("North",text);
 add("South",okP);
 ok.addActionListener(this);
 cancel.addActionListener(this);

 setVisible(true);
}

public void actionPerformed(ActionEvent e)
{
 if(e.getSource() == ok)
 {
  setVisible(false);

  if(type.equals("local"))
  {
   File f = new File(who.path + text.getText());
   if(!f.mkdir()) JFtp.debugWrite("Can't create directory!");
  }
  if(type.equals("remote"))
  {
   FtpConnection.jcon.send("MKD "+text.getText());
   String tmpx = Resource.getLine("257");
  }

  if(type.equals("local")) who.setPath(who.path);
  if(type.equals("remote")) who.setRemotePath(who.path);
 }

 if(e.getSource() == cancel) {this.dispose();}
}

}