import java.awt.*;

public class HTextField extends Panel
{
 private Label label;
 public TextField text;

public HTextField(String l, String t)
{
 setBackground(Settings.mainBack);
 setForeground(Settings.front);
 setLayout(new BorderLayout(5,5));

 label = new Label(l + "  ");
 add("West",label);

 text = new TextField(t);
 add("Center",text);
 text.setForeground(Settings.front);
 text.setBackground(Settings.back);

 setVisible(true);
}

public String getLabel()
{
 return label.getText();
}

public void setLabel(String l)
{
 label.setText(l+ "  ");
}

public String getText()
{
 return text.getText();
}

public void setText(String t)
{
 text.setText(t);
}

}