import java.awt.*;
import java.awt.event.*;

public class HostChooser extends HFrame implements ActionListener, WindowListener {

public static HTextField host = new HTextField("Hostname:","localhost");
public static HTextField user = new HTextField("Username:","anonymous");
public static HTextField pass = new HTextField("Password:","none@nowhere.no");

private HPanel okP = new HPanel();
private HButton ok = new HButton("Use this!");

private HPanel listP = new HPanel();
private HButton list = new HButton("Choose from or edit list...");

public HostChooser()
{
 setSize(400,250);
 setLocation(100,150);
 setTitle("Connection...");
 setLayout(new GridLayout(5,1));

 add(host);
 add(user);
 add(pass);

 LoadSet l = new LoadSet();
 String login[] = l.loadSet("cfg/.login_default");

if(login != null)
{
 host.setText(login[0]);
 user.setText(login[1]);
}

 pass.text.setEchoChar('*');
 if(Settings.cachePass)
 {
  if(login != null)
  {
   pass.setText(login[2]);
  }
 }
 else pass.setText("");

 add(okP);
 okP.add(ok);
 ok.addActionListener(this);

 add(listP);
 listP.add(list);
 list.addActionListener(this);

 addWindowListener(this);

 setVisible(true);
}

public void actionPerformed(ActionEvent e)
{
 if(e.getSource() == ok)
 {
  JFtp.setHost(host.getText());
  String htmp = Resource.cut(host.getText()," ");
  String utmp = Resource.cut(user.getText()," ");
  String ptmp = Resource.cut(pass.getText()," ");
  SaveSet s = new SaveSet("cfg/.login_default",htmp,utmp,ptmp);
  FtpConnection con = new FtpConnection(htmp,utmp,ptmp);
  this.dispose();
 }

 if(e.getSource() == list)
 {
  HostList hl = new HostList();
 }
}

public Insets getInsets()
{
 Insets std = super.getInsets();
 return new Insets(std.top + 15, std.left + 15, std.bottom + 15, std. right + 15);
}

public void windowClosing(WindowEvent e) {} //this.dispose();}
public void windowClosed(WindowEvent e) {} 
public void windowActivated(WindowEvent e) {} 
public void windowDeactivated(WindowEvent e) {} 
public void windowIconified(WindowEvent e) {} 
public void windowDeiconified(WindowEvent e) {} 
public void windowOpened(WindowEvent e) {} 

}
