import java.net.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;

public class JFtp extends Frame implements WindowListener, Runnable
{
 public static StatusPanel statusP = new StatusPanel();
 public static Label statusL = new Label("JFtp : any comments?   mailto:cyberdemon@x-cas.de                ");

 public static DirPanel localDir;
 public static DirPanel remoteDir;

 private LoadPanel loadP = new LoadPanel();

 private HPanel optP = new HPanel();
 private HPanel dirP = new HPanel();
 public static TextArea log;

 private Thread runner;


public JFtp()
{
 // main init
 setSize(665,550);
 setLocation(0,25);
 setTitle(Settings.title);
 setLayout(new BorderLayout());
 setBackground(Settings.mainBack);
 setForeground(Settings.front);
 setResizable(Settings.resize);

 add("North",statusP);

 log = new TextArea();
 optP.setLayout(new BorderLayout());
 optP.add("Center",log);
 add("South",optP);
 log.setBackground(Settings.back);
 log.setForeground(Settings.front);
 log.setEditable(false);

// dirP
 dirP.setLayout(null);
 dirP.setSize(640,400);
 localDir = new DirPanel("./",300,300,"local");
 localDir.setLocation(0,0);
 localDir.setSize(300,300);
 localDir.layout();
 loadP.setBounds(300,0,40,300);
 remoteDir = new DirPanel("/",300,300,"remote");
 remoteDir.setBounds(340,0,300,300);
 dirP.add(localDir);
 dirP.add(loadP);
 dirP.add(remoteDir);
// dirP.add(remoteDir);

 add("Center",dirP);
// ~dirP


// starting
addWindowListener(this);

Image icon = HImage.getImage(this,Settings.iconImage);
setIconImage(icon);

validate();

setFont(Settings.font);
setVisible(true);

HostChooser hc = new HostChooser();

runner = new Thread(this);
runner.start();
}

public void run() {}

public static String getHost()
{
 return statusP.status.host;
}

public static void setHost(String which)
{
 statusP.status.host = which;
}

public static void localUpdate()
{
 localDir.setPath(localDir.path);
}

public static void remoteUpdate()
{
 remoteDir.setRemotePath(remoteDir.path);
}

public void windowClosing(WindowEvent e) {System.exit(0);}
public void windowClosed(WindowEvent e) {}
public void windowActivated(WindowEvent e) {}
public void windowDeactivated(WindowEvent e) {}
public void windowIconified(WindowEvent e) {}
public void windowDeiconified(WindowEvent e) {}
public void windowOpened(WindowEvent e) {}


public static void main(String argv[])
{
 StatusPanel.jftp = new JFtp();
}

public static void debugWrite(String msg)
{
 if(!msg.startsWith("200") && !msg.startsWith("227"))
 {
  log.append(msg+"\n");
 }
}

public Insets getInsets() 
{ 
Insets in = super.getInsets();
return new Insets(in.top+5,in.left+5,in.bottom+5,in.right+5); 
}

}
