import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;

public class LoadPanel extends HPanel implements ActionListener
{
 private HButton up = new HButton("->");
 private HButton down = new HButton("<-");

public LoadPanel()
{
 setLayout(new GridLayout(12,1,2,2));
 setSize(40,400);

 add(new Template());
 add(new Template());
 add(new Template());
 add(up);
 add(new Template());
 add(new Template());
 add(new Template());
 add(down);
 add(new Template());
 add(new Template());
 add(new Template());
 add(new Template());

 up.addActionListener(this);
 down.addActionListener(this);

 setVisible(true);
}

public void upload()
{
 for(int i=0; i<JFtp.localDir.length;i++)
 {
  if(JFtp.localDir.dirEntry[i].selected)
  {
   Resource.upload(JFtp.localDir.dirEntry[i].file);
  }
 }

 JFtp.debugWrite("Finished upload...");
}

public void download()
{

 for(int i=0; i<JFtp.remoteDir.length;i++)
 {
  if(JFtp.remoteDir.dirEntry[i].selected)
  {
   Resource.download(JFtp.remoteDir.dirEntry[i].file);
  }
 }

 JFtp.debugWrite("Finished download...");
}


public void actionPerformed(ActionEvent e)
{
 if(e.getSource() == up) {upload();}
 if(e.getSource() == down) {download();}
}

/*
public Insets getInsets()
{
 Insets in = super.getInsets();
 return new Insets(in.top+5,in.left+5,in.bottom+5,in.right+5);
}
*/

}