import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class PathChanger extends HFrame implements ActionListener
{
 private HTextField text;
 private HButton ok = new HButton("Change Directory");
 private HPanel okP = new HPanel();
 private String type = "";

public PathChanger(String type)
{
 this.type = type;

 setSize(300,100);
 setTitle("Choose path...");
 setLocation(150,150);
 setLayout(new BorderLayout(10,10));

 text = new HTextField("Path:","");
 okP.add(ok);
 add("North",text);
 add("South",okP);
 ok.addActionListener(this);

 setVisible(true);
}

public void actionPerformed(ActionEvent e)
{
 if(e.getSource() == ok)
 {
  setVisible(false);
  if(type.equals("remote")) {JFtp.remoteDir.setRemotePath(text.getText());}
  if(type.equals("local")) {JFtp.localDir.setPath(text.getText());}
 }
}

}