import java.net.*;
import java.lang.reflect.*;
import java.io.*;

public class Resource
{

public static final boolean removeSpaces = true;
public static final int connectionTimeout = 20000;

public static String getCanonicalPath(String path)
{
// System.out.println(path);
 String seg = null;
 String off = "";

 for(int i=0; i<path.length()-2; i++)
 {
  if(path.charAt(i) == '/')
  {
   if(path.charAt(i+1) == '.')
   {
    if(path.charAt(i+2) == '.')
    {
     seg = path.substring(0,i+1);
//   System.out.println("seg: "+seg);
     off = path.substring(i+4);
//   System.out.println("off: "+off);
     boolean fin = false;

     for(int j=seg.length()-1; j>0; j--)
     {
      if(fin) break;
      if(seg.charAt(j-1) == '/') {seg = seg.substring(0,j-1); fin = true;}
     }
    }
   }
  }
}

 if(seg == null) return path;

 if(!seg.endsWith("/")) seg = seg + "/";
 seg = seg + off;
// System.out.println("path: "+seg);
 return seg;
}

public static String getFile(String path)
{
 while(strstr(path,'/'))
 {
  cutAfter(path,'/');
 }
// System.out.println(path);

 return path;
}

public static String[] sortSize(String file)
{
 DataInputStream in = null;
 PrintStream out = null;
 int length = 0;
 try
 {
  in = new DataInputStream(new FileInputStream(file));
  out = new PrintStream(new FileOutputStream("cfg/.sortsize_out"));

  while(true)
  {
   String tmp = in.readLine();
   if(tmp == null) break;
   length++;

//   System.out.println(tmp);

   if(tmp.length() >= 20)
   {
    int x = tmp.length();
    int y = x-1;

    for(int i=0; i<4; i++)
    {
     while(tmp.charAt(y) != ' ') y--;
     while(tmp.charAt(y) == ' ') y--;
    }

    int z = 1;
    while(tmp.charAt(y) != ' ') {y--; z++;}
    String s = tmp.substring(y+1,y+z);
//    System.out.println(s);

    out.println(s);
   }
  }
  }
  catch(Exception ex) {JFtp.debugWrite(ex.toString()+" @Resource::sortSize#1");}

 try
 {
  in = new DataInputStream(new FileInputStream("cfg/.sortsize_out"));
  String[] files = new String[length];

  for(int i=0; i<length; i++)
  {
   files[i] = in.readLine();
//   System.out.println(files[i]);
  }
  return files;
 }
 catch(Exception ex) {JFtp.debugWrite(ex.toString()+" @Resource::sortSize#2");}

 return new String[0];
}

public static String[] sortLs(String file)
{
 try
 {
  DataInputStream in = new DataInputStream(new FileInputStream(file));
  PrintStream out = new PrintStream(new FileOutputStream("cfg/.sortls_out"));
  int length = 0;

  while(true)
  {
   String tmp = in.readLine();
   if(tmp == null) break;
//   System.out.println(tmp);

   if(tmp.length() >= 20)
   {
    if(tmp.startsWith("d"))
    {
     for(int i=tmp.length()-1; i>0; i--)
     {
      if(tmp.charAt(i) == ' ')
      {
       out.println(tmp.substring(i+1)+"/");
       break;
      }
     }
    }
    else
    {
     for(int i=tmp.length()-1; i>0; i--)
     {
      if(tmp.charAt(i) == ' ')
      {
       out.println(tmp.substring(i+1));
       break;
      }
     }
    }
    length++;
   }
  }

  in = new DataInputStream(new FileInputStream("cfg/.sortls_out"));
  String[] files = new String[length];

  for(int i=0; i<length; i++)
  {
   files[i] = in.readLine();
  }
//   System.out.println(files[i]);
  return files;
 }
 catch(Exception ex) {JFtp.debugWrite(ex.toString()+" @Resource::sortLs");}

 return new String[0];
}

public static int getPasvPort(String str)
{
 JFtp.debugWrite(str);

 str = cutAfter(str,',');
 str = cutAfter(str,',');
 str = cutAfter(str,',');
 str = cutAfter(str,',');

 String up = "";
 int i = 0;
 while(str.charAt(i) != ',') {up += str.charAt(i); i++;}

 str = cutAfter(str,',');

 String down = "";
 int j = 0;
 while(str.charAt(j) != ')') {down += str.charAt(j); j++;}

 int ret = (Integer.parseInt(up)*256 + Integer.parseInt(down));
// System.out.println(""+ret);
 return ret;
}

public static String cutAfter(String str, char c)
{
 for(int i=0; i<str.length(); i++)
 {
  if(str.charAt(i) == c)
  {
//   System.out.println(str.substring(i+1));
   return str.substring(i+1);
  }
 }
 return str;
}

public boolean test(String host, int port)
{
 JConnection jcon1 = new JConnection(host, port);
 if(!jcon1.isThere()) {return false;}
 else {return true;}
}

public static void pause(int time)
{
 try{Thread.sleep(time);}
 catch(Exception ex) {System.out.println(ex);}
}


public static int getLength(Object[] arg)
{
 int cnt = 0;
 try{
  for(int i = 0; i < 100; i++)
  {
   if(arg[i] != null)
   {
    cnt++;
   }
  }
    }
 catch(Exception ex) {}

 return cnt;
}

public static boolean contains(String[] tmp, String str)
{
 for(int i=0; i<Resource.getLength(tmp); i++)
 {
  if(tmp[i].startsWith(str)) {return true;}
 }
 return false;
}

public static boolean strstr(String tmp, char str)
{
 for(int i=0; i<tmp.length(); i++)
 {
  if(tmp.charAt(i) == str) {return true;}
 }
 return false;
}

public static String cut(String tmp, String where)
{
 StringBuffer ret = new StringBuffer();
 for(int i=0; i<tmp.length(); i++)
 {
  if(!string(tmp.charAt(i)).equals(where))
  {
   ret.append(string(tmp.charAt(i)));
  }
  if(string(tmp.charAt(i)).equals(where))
  {
   return ret.toString();
  }
 }
 return ret.toString();
}

public static String getLine(String until)
{
 DataInputStream in = null;

 try
 {
  in = new DataInputStream(FtpConnection.jcon.getInetInputStream());
 }
 catch(Exception ex) {JFtp.debugWrite(ex.toString()+" @Resource::getLine");}

 while(true)
 {
  String[] tmp = new String[100];

  for(int i=0; i<100; i++)
  {
   try {
        tmp[i] = in.readLine();
        if(tmp[i] == null) {break;}

        JFtp.debugWrite(tmp[i]);

        if(tmp[i].startsWith("530")) {break;}
        if(tmp[i].startsWith("550")) {break;}
        if(tmp[i].startsWith("553")) {break;}

        if(tmp[i].startsWith(until))
        {
         return tmp[i];
        }
       }
  catch(Exception ex) {JFtp.debugWrite(ex.toString() + " @Resource::getLine"); break;}
  }
  return null;
 }
}

public static String string(char c)
{
 char[] buf = new char[1];
 buf[0] = c;
 return new String(buf);
}

public static void download(String file)
{
 String path = null;

  try
   {
    path = JFtp.localDir.path + file;
    DataInputStream in = new DataInputStream(FtpConnection.jcon.getInetInputStream());

    FtpConnection.jcon.send("PASV");
    String tmp = Resource.getLine("227");
    int port = Resource.getPasvPort(tmp);
    FtpConnection.jcon.send("MODE S");
    Resource.getLine("200");
    FtpConnection.jcon.send("TYPE I");
    Resource.getLine("200");
    DataConnection dcon = new DataConnection(port,JFtp.getHost(),path,"RECV");
    while(!dcon.isThere) Resource.pause(100);
    FtpConnection.jcon.send("RETR " + file);
    JFtp.debugWrite(in.readLine());

    while(!dcon.finished)
    {
     Resource.pause(100);
    }
    JFtp.debugWrite("Finished file: "+file);
   }
   catch(Exception ex) {JFtp.debugWrite(ex.toString()+" @Resource::download");}

//  JFtp.debugWrite("Finished download...");
  JFtp.localUpdate();
}

public static void upload(String file)
{
 String path = null;

 try
   {
    path = JFtp.localDir.path + file;
    DataInputStream in = new DataInputStream(FtpConnection.jcon.getInetInputStream());

    FtpConnection.jcon.send("PASV");
    String tmp = Resource.getLine("227");
    int port = Resource.getPasvPort(tmp);
    FtpConnection.jcon.send("MODE S");
    Resource.getLine("200");
    FtpConnection.jcon.send("TYPE I");
    Resource.getLine("200");
    DataConnection dcon = new DataConnection(port,JFtp.getHost(),path,"SEND");
    while(!dcon.isThere) Resource.pause(100);
    JFtp.debugWrite("File: "+file);

    FtpConnection.jcon.send("STOR " + file);
    JFtp.debugWrite(in.readLine());

    while(!dcon.finished)
    {
     Resource.pause(100);
    }
    JFtp.debugWrite("Finished file: "+file);
   }
   catch(Exception ex) {JFtp.debugWrite(ex.toString()+" @Resource::upload");}

//  JFtp.debugWrite("Finished upload...");
  JFtp.remoteUpdate();
}

public static String removeStart(String str, String what)
{
 if(str.startsWith(what))
 {
  int x = what.length();
  return str.substring(x);
 }
 else return str;
}

public static void remoteCmd(String cmd)
{
 DataInputStream in = new DataInputStream(FtpConnection.jcon.getInetInputStream());
 FtpConnection.jcon.send("NOOP");
 getLine("200");
 FtpConnection.jcon.send(cmd);
 FtpConnection.jcon.send("NOOP");
 getLine("200");
}

public static void uploadDir(String dir,String path)
{
 if(dir.endsWith("\\")) {System.out.println("oops... fucked up, need to fix \\-problem!!!");}

 if(!dir.endsWith("/")) {dir = dir + "/";}
 String remoteDir = removeStart(dir,path);
 remoteCmd("MKD "+remoteDir);
// System.out.println(dir);
// System.out.println(path);

 File f2 = new File(path+dir);
 String tmp[] = f2.list();

 for(int i=0; i<getLength(tmp); i++)
 {
  File f3 = new File(path+dir+tmp[i]);

  if(f3.isDirectory())
  {
//   System.out.println(dir);
   uploadDir(dir+tmp[i],path);
  }
  else
  {
//   System.out.println(dir+tmp[i]);
   upload(dir+tmp[i]);
  }
 }
}

public static void downloadDir(String dir, String path)
{
 if(!dir.endsWith("/")) {dir = dir + "/";}
 String remoteDir = removeStart(dir,path);

// System.out.println(remoteDir);
// System.out.println(path);

 File f = new File(JFtp.localDir.path + remoteDir);

 if(!f.exists())
 {
  if(!f.mkdir()) {JFtp.debugWrite("Can't create directory: "+remoteDir);}
  else JFtp.debugWrite("Created directory...");
 }

 String oldDir = JFtp.remoteDir.path;
 JFtp.remoteDir.setRemotePath(JFtp.remoteDir.path+remoteDir);

 DirLister dl = new DirLister(remoteDir,"remote");
 String tmp[] = dl.list();
 JFtp.remoteDir.setRemotePath(oldDir);

 for(int i=0; i<getLength(tmp); i++)
 {
  if(tmp[i].endsWith("/"))
  {
//   System.out.println(dir);
   downloadDir(dir+tmp[i],path);
  }
  else
  {
//   System.out.println(dir+tmp[i]);
   download(dir+tmp[i]);
  }
 }

}

public static void cleanLocalDir(String dir,String path)
{
 if(dir.endsWith("\\")) {System.out.println("oops... fucked up, need to fix \\-problem!!!");}

 if(!dir.endsWith("/")) {dir = dir + "/";}
 String remoteDir = removeStart(dir,path);

 File f2 = new File(path+dir);
 String tmp[] = f2.list();

 for(int i=0; i<getLength(tmp); i++)
 {
  File f3 = new File(path+dir+tmp[i]);

  if(f3.isDirectory())
  {
//   System.out.println(dir);
   cleanLocalDir(dir+tmp[i],path);
   f3.delete();
  }
  else
  {
//   System.out.println(dir+tmp[i]);
   f3.delete();
  }
 }
}


public static void cleanRemoteDir(String dir, String path)
{
 if(!dir.endsWith("/")) {dir = dir + "/";}
 String remoteDir = removeStart(dir,path);

 String oldDir = JFtp.remoteDir.path;
 JFtp.remoteDir.setRemotePath(JFtp.remoteDir.path+remoteDir);

 DirLister dl = new DirLister(remoteDir,"remote");
 String tmp[] = dl.list();
 JFtp.remoteDir.setRemotePath(oldDir);

 for(int i=0; i<getLength(tmp); i++)
 {
  if(tmp[i].endsWith("/"))
  {
//   System.out.println(dir);
   cleanRemoteDir(dir+tmp[i],path);
   remoteCmd("DELE "+dir+tmp[i]);
  }
  else
  {
//   System.out.println(dir+tmp[i]);
   remoteCmd("DELE "+dir+tmp[i]);
  }
 }

}

}