import java.awt.*;

public class StatusCanvas extends Canvas
{
 int y = 15;
 int hx = 10;
 int tx = 300;
 String host = "localhost";
 String text = Settings.greeting;

public StatusCanvas()
{
 setVisible(true);
 repaint();
}

public void setText(String msg)
{
 text = msg;
 repaint();
}

public void setHost(String h)
{
 host = h;
 repaint();
}

public void paint(Graphics g)
{
 g.setColor(Settings.mainBack);
 g.fillRect(0,0,getSize().width,getSize().height);
 g.setColor(Settings.front);
 g.setFont(Settings.font);
 g.drawString(host,hx,y);
 g.setColor(Settings.mainBack);
 g.fillRect(tx-10,0,getSize().width,getSize().height);
 g.setColor(Settings.front);
 g.drawString(text,tx,y);
}

public void update(Graphics g)
{
 paint(g);
}



}