import java.awt.*;
import java.awt.event.*;

public class StatusPanel extends HPanel implements ActionListener
{
 private HImageButton newcon = new HImageButton("images/host.gif","newcon","New Connection...",this);
 private HImageButton close = new HImageButton("images/stop.gif","close","Exit JFtp...",this);
 private HImageButton info = new HImageButton("images/info.gif","info","About JFtp...",this);

 public static JFtp jftp;
 public StatusCanvas status = new StatusCanvas();

 private Font f = new Font("serif",Font.PLAIN,12);

public StatusPanel()
{
 // main init
 setLayout(new FlowLayout(FlowLayout.LEFT));

 add(newcon);
 newcon.setSize(24,24);
 add(close);
 close.setSize(24,24);
 add(info);
 info.setSize(24,24);
 add(status);
 status.setSize(500,24);

validate();

setFont(Settings.menuFont);
setVisible(true);
}

public void status(String msg)
{
 status.setText(msg);
}

public void actionPerformed(ActionEvent e)
{
 if(e.getActionCommand().equals("info")) {Displayer d = new Displayer(Settings.readme);}
 if(e.getActionCommand().equals("close")) {System.exit(0);}
 if(e.getActionCommand().equals("newcon")) {jftp.dispose(); jftp = new JFtp();}
}

public Insets getInsets() 
{ 
Insets in = super.getInsets();
return new Insets(in.top+5,in.left+5,in.bottom+5,in.right+5); 
}

}
