import java.lang.reflect.*;
import java.io.*;

public class FtpConnection implements Runnable
{
 private final int maxlen = 200;
 private final int port = 21;
 private final int dataport = 20;
 private String host = "";
 private Thread runner;
 private boolean msg = true;
 private boolean fin = false;
 private boolean ok = true;
 private String user;
 private String pass;
 public static DataInputStream in;
 public static JConnection datacon;
 public static JConnection jcon;

public FtpConnection(String host, String user, String pass)
{
 this.host = host;
 this.user = user;
 this.pass = pass;
 fin = false;

 if(host != null && !(host.length()<4))
 {
  runner = new Thread(this);
  runner.start();
 }
}

public void run()
{
 if(msg) { JFtp.debugWrite("Connecting to "+host); }
 jcon = new JConnection(host,port);

if(jcon.isThere())
 {
  in = jcon.getInetInputStream();
//  datacon = new JConnection(host,dataport);

   getStream("220");
   if(msg) { JFtp.debugWrite("Connection established..."); }

   jcon.send("USER " + user);

   if(Resource.contains(getStream("331"),"331"))
   {
    jcon.send("PASS " + pass);

    if(Resource.contains(getStream("230"),"230")) {if(msg) JFtp.debugWrite("Logged in...");}
    else {JFtp.debugWrite("Wrong password!"); ok = false;}
  }

// end if(jcon)...
 }
 else {if(msg) {JFtp.debugWrite("FTP not available!"); ok = false;}}

 if(ok)
 {
//  JFtp.debugWrite("Connection established...");
  jcon.send("PWD");
  String pwd = Resource.getLine("257");

  pwd = pwd.substring(5,pwd.length());
  String p = "";

  for(int i=0; i<pwd.length(); i++)
  {
   if(pwd.charAt(i) == '"') break;
   else
   {
    Character c = new Character(pwd.charAt(i));
    p = p + c.toString();
   }
  }

//  System.out.println("path: "+p);
  JFtp.remoteDir.setRemotePath(p);
 }
}

private String[] getStream(String until)
{
 while(true)
 {
  String[] tmp = new String[maxlen];

  for(int i=0; i<maxlen; i++)
  {
//   if(msg) { JFtp.debugWrite("Run: "+i); }
   try {
        tmp[i] = in.readLine();
        if(tmp[i] == null) {break;}

        JFtp.debugWrite(tmp[i]);

        if(tmp[i].startsWith("530")) {break;}
        if(tmp[i].startsWith("550")) {break;}

        // JFtp.status.setText(host+": "+tmp[i]+"\n");

        if(tmp[i].startsWith(until))
        {
         break;
        }
       }
  catch(Exception ex) {JFtp.debugWrite(ex.toString() + " @FtpConnection::getStream"); break;}
  }
  return tmp;
 }
}

public void setFin() {fin = true;}

}
